angular.module('app.controllers', [])

.controller('dashboardCtrl', function($scope, $rootScope, $state, $localStorage, $localStorage, $ionicHistory, $translate, AppConfig, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.dashboard.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });

    $scope.openApplicationSettings = function() {
        $ionicHistory.nextViewOptions({
            disableBack: true
        });
        $state.go('menu.applicationSettings');
    }

    $scope.doRefresh = function() {
        if ($rootScope.UserLocationError !== false) {
            $rootScope.initWatchPosition();
        }
        $rootScope.$broadcast('doRefresh');
        $scope.$broadcast('scroll.refreshComplete');
    };

    $scope.$storage = $localStorage;

    $scope.go = function(state, params) {
        params = params || {};
        if (params.hasOwnProperty("LocationID")) {
            $rootScope.GetMapDataEx.LocationID = params.LocationID;
        }
        $ionicHistory.nextViewOptions({
            disableBack: true
        });
        $state.go(state);
    }
})

.controller('bugReportCtrl', function($scope, $ionicLoading, FrontendService, $ionicScrollDelegate, $localStorage, AppConfig, $http, $translate, AppConfig, GetMapDataEx, Toast, $filter, $rootScope, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.bugReport.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });
    $scope.storage = $localStorage;
    $scope.sending = false;

    $scope.$on('bugReportBack', function(event, args) {
        if ($rootScope.keys($scope.report).length == 2) {
            navigator.app.backHistory();
        }
        $scope.back();
    });

    $scope.$on('$ionicView.beforeEnter', function() {
        $scope.reset();
        $scope.position = false;

        $scope.placeholder = "";
        $translate("pages.bugReport.tree.note.label").then(function(string) {
            $scope.placeholder = parseHtmlEnteties(string);
        });
    });

    $scope.Locations = [];

    $scope.isLast = function() {
        if ($rootScope.keys($scope.report).length > 1) return true;
        return false;
    }

    $scope.branch = function(code) {
        if ($scope.finished.spinner[code] == true) return false;
        if ($scope.report.hasOwnProperty(code) && $scope.report[code] != '') {
            return true;
        }
        return false;
    }

    $scope.showButtons = function(code) {
        var show = true;
        if ($scope.path.hasOwnProperty(code) && $scope.path[code] && $scope.path[code] != '') {
            show = false;
        }
        return show;
    }

    $scope.isFinished = function() {
        if ($scope.finished['done'] == true) {
            return true;
        }
        return false;
    }

    $scope.sendFailed = function() {
        $translate("pages.bugReport.reportSentFailed").then(function(string) {
            Toast.show(string + " " + AppConfig.bugReport.email);
        });
    }

    $scope.send = function() {
        $scope.sending = true;

        var keys = [];

        angular.forEach($scope.report, function(value, key) {
            keys.push("pages.bugReport.tree." + key + ".label");
        });

        $scope.message = [];

        $translate(keys).then(function(strings) {
            var data = {
                operation: "bugReport"
            };

            $ionicScrollDelegate.scrollTop();

            angular.forEach($scope.report, function(value, key) {
                if (typeof value != 'object' && typeof value !== 'boolean') {
                    var master = 'position';

                    if (key == "note") {
                        master = "note";
                    } else {
                        for (i in $scope.path) {
                            if ($scope.path[i] == key) {
                                master = i;
                                break;
                            }
                        }
                    }

                    $scope.message.push(parseHtmlEnteties(strings["pages.bugReport.tree." + master + ".label"]) + ": " + value);
                }
            });

            var messageDetail = [];
            angular.forEach($scope.report['checklist-detail'], function(value, key) {
                angular.forEach(value, function(data) {
                    messageDetail.push(data);
                });
            });

            if (messageDetail.length > 0) {
                $scope.message.push(strings["pages.bugReport.details"] + ": " + messageDetail.join(", "));
            }

            var ActiveContracts = [];

            angular.forEach($filter("filter")($scope.storage.TKCustomerContracts.Contracts, {
                StatusCode: 2
            }, true), function(data) {
                ActiveContracts.push(data.BusinessRuleName);
            });

            $ionicLoading.show();

            FrontendService.post("bug-report", {
                    Message: $scope.message,
                    Contracts: ActiveContracts,
                    Platform: $rootScope.platform,
                    Version: ionic.Platform.version(),
                    App: AppConfig.version
                },
                function() {
                    $scope.sending = false;
                    $ionicLoading.hide();
                    $translate("pages.bugReport.reportSent").then(function(string) {
                        Toast.show(string);
                    });
                    $scope.reset();
                },
                function() {
                    $scope.sending = false;
                    $scope.sendFailed();
                    $ionicLoading.hide();
                },
                function() {
                    $scope.sending = false;
                    $scope.sendFailed();
                    $ionicLoading.hide();
                });
        });
    }

    $scope.back = function() {
        $scope.finished["done"] = false;
        for (key in $scope.path) {
            if ($scope.path[key] == $scope.finished.last["slave"]) {
                delete $scope.report[$scope.finished.last["slave"]];
                $scope.finished.last["slave"] = key;
            }
        }

        for (key in $scope.path) {
            if ($scope.path[key] == $scope.finished.last["master"]) {
                delete $scope.path[$scope.finished.last["master"]];
                $scope.finished.last["master"] = key;
            }
        }

        if ($rootScope.keys($scope.report).length == 4) {
            $scope.reset();
        }
    }

    $scope.reset = function() {
        $scope.path = {
            "position": true
        };
        var location = false;
        if ($scope.hasOwnProperty("report") && $scope.report.hasOwnProperty("location")) {
            location = $scope.report["location"];
        }
        $scope.report = {
            "position": true,
            "checklist": {},
            "checklist-detail": {}
        };
        if (location !== false) {
            $scope.report["location"] = location;
        }
        $scope.finished = {
            'last': {},
            'done': false,
            'spinner': {}
        };
    }

    $translate(["pages.bugReport.tree.station.button", "pages.bugReport.tree.keyboard.button", "pages.bugReport.tree.brokenKeyboard.button", "pages.bugReport.tree.freezeKeyboard.button", "pages.bugReport.tree.touchscreen.button", "pages.bugReport.tree.brokenTouchscreen.button", "pages.bugReport.tree.freezeTouchscreen.button", "pages.bugReport.tree.lock.button", "pages.bugReport.tree.otherStation.button", "pages.bugReport.tree.bike.button", "pages.bugReport.tree.other.button", "pages.bugReport.tree.cableLock.label", "pages.bugReport.tree.light.label", "pages.bugReport.tree.seddle.label", "pages.bugReport.tree.basket.label", "pages.bugReport.tree.ring.label", "pages.bugReport.tree.construction.label", "pages.bugReport.tree.pneu.label", "pages.bugReport.tree.engine.label"]).then(function(string) {
        $scope.tree = {
            "position": {
                "child": {
                    "location": {
                        "type": "list",
                        "options": "locationList",
                        "child": {
                            "station": {
                                "button": parseHtmlEnteties(string["pages.bugReport.tree.station.button"]),
                                "icon": "map-marker",
                                "child": {
                                    "keyboard": {
                                        "button": parseHtmlEnteties(string["pages.bugReport.tree.keyboard.button"]),
                                        "icon": "keyboard-o",
                                        "child": {
                                            "brokenKeyboard": {
                                                "button": parseHtmlEnteties(string["pages.bugReport.tree.brokenKeyboard.button"]),
                                                "icon": "chain-broken"
                                            },
                                            "freezeKeyboard": {
                                                "button": parseHtmlEnteties(string["pages.bugReport.tree.freezeKeyboard.button"]),
                                                "icon": "spinner"
                                            }
                                        }
                                    },
                                    "touchscreen": {
                                        "button": parseHtmlEnteties(string["pages.bugReport.tree.touchscreen.button"]),
                                        "icon": "tablet",
                                        "child": {
                                            "brokenTouchscreen": {
                                                "button": parseHtmlEnteties(string["pages.bugReport.tree.brokenTouchscreen.button"]),
                                                "icon": "chain-broken"
                                            },
                                            "freezeTouchscreen": {
                                                "button": parseHtmlEnteties(string["pages.bugReport.tree.freezeTouchscreen.button"]),
                                                "icon": "hourglass-start"
                                            }
                                        }
                                    },
                                    "lock": {
                                        "button": parseHtmlEnteties(string["pages.bugReport.tree.lock.button"]),
                                        "icon": "lock",
                                        "child": {
                                            "lockId": {
                                                "type": "list",
                                                "options": "lockList",
                                            }
                                        }
                                    },
                                    "otherStation": {
                                        "button": parseHtmlEnteties(string["pages.bugReport.tree.otherStation.button"]),
                                        "icon": "question"
                                    }
                                }
                            },
                            "bike": {
                                "button": parseHtmlEnteties(string["pages.bugReport.tree.bike.button"]),
                                "icon": "bicycle",
                                "child": {
                                    "bikeId": {
                                        "type": "list",
                                        "options": "bikeList",
                                        "input": true,
                                        "default": "-- vyberte kolo --",
                                        "child": {
                                            "bikeProblem": {
                                                "type": "checklist",
                                                "options": "bikeProblem",
                                                "child": {
                                                    "cableLock": {
                                                        "label": parseHtmlEnteties(string["pages.bugReport.tree.cableLock.label"]),
                                                        "icon": "lock"
                                                    },
                                                    "light": {
                                                        "label": parseHtmlEnteties(string["pages.bugReport.tree.light.label"]),
                                                        "icon": "lightbulb-o"
                                                    },
                                                    "seddle": {
                                                        "label": parseHtmlEnteties(string["pages.bugReport.tree.seddle.label"]),
                                                        "icon": "thumbs-down",
                                                    },
                                                    "basket": {
                                                        "label": parseHtmlEnteties(string["pages.bugReport.tree.basket.label"]),
                                                        "icon": "shopping-basket"
                                                    },
                                                    "ring": {
                                                        "label": parseHtmlEnteties(string["pages.bugReport.tree.ring.label"]),
                                                        "icon": "bell-o"
                                                    },
                                                    "construction": {
                                                        "label": parseHtmlEnteties(string["pages.bugReport.tree.construction.label"]),
                                                        "icon": "wrench"
                                                    },
                                                    "pneu": {
                                                        "label": parseHtmlEnteties(string["pages.bugReport.tree.pneu.label"]),
                                                    },
                                                    "engine": {
                                                        "label": parseHtmlEnteties(string["pages.bugReport.tree.engine.label"]),
                                                        "icon": "link"
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            },
                            "other": {
                                "button": parseHtmlEnteties(string["pages.bugReport.tree.other.button"]),
                                "icon": "question"
                            }
                        }
                    }
                }
            }
        };
    });
})

.controller('InfosCtrl', function($scope, GetInfosService, $localStorage, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.Infos.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });
    $scope.storage = $localStorage;
    $scope.$on('$ionicView.beforeEnter', function() {
        GetInfosService.load();
    });
})

.controller('ContactsCtrl', function($scope, $http, $ionicLoading, Toast, $timeout, GetContactsService, $localStorage, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.Contacts.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });

    $scope.storage = $localStorage;
    $scope.sending = false;
    $scope.subjectPrefix = false;
    $translate("pages.Contacts.ContactForm.subjectPrefix").then(function(string) {
        $scope.subjectPrefix = string;
    });

    $scope.form = {
        subject: "",
        message: ""
    };

    $scope.sendFailed = function() {
        $translate("pages.Contacts.ContactForm.sendFailed").then(function(string) {
            Toast.show(string + " " + AppConfig.bugReport.email);
        });
    }

    $scope.submit = function() {
        $scope.sending = true;

        var data = {
            operation: "ContactForm"
        };

        var LabelCustomerID = "Customer: " + $scope.storage.TKCustomer.CustomerID + ", " + $scope.storage.TKCustomer.EmailAddress;

        var email = {
            "subject": $scope.subjectPrefix + ": " + $scope.form.subject + " (" + LabelCustomerID + ")",
            "message": $scope.form.message + "<br />" + LabelCustomerID
        };

        data.data = email;

        $http.post(AppConfig.url + "tkhs-app-service.html", data).then(function(response) {
            $scope.sending = false;
            response = angular.fromJson(response);

            if (typeof response.data != 'object' || response.data.error === true || response.data.success === false) {
                $scope.sendFailed();
            } else {
                $translate("pages.Contacts.ContactForm.sent").then(function(string) {
                    Toast.show(string);
                });
                $scope.reset();
            }
        }, function(err) {
            $scope.sending = false;
            $scope.sendFailed();
        });
    }

    $scope.reset = function() {
        $scope.form.subject = "";
        $scope.form.message = "";
    }

    $scope.questionPlaceholder = "";
    $translate("pages.Contacts.ContactForm.questionPlaceholder").then(function(string) {
        $scope.questionPlaceholder = parseHtmlEnteties(string);
        $scope.questionPlaceholder = string;
    });

    $scope.subjectPlaceholder = "";
    $translate("pages.Contacts.ContactForm.subjectPlaceholder").then(function(string) {
        $scope.subjectPlaceholder = parseHtmlEnteties(string);
        $scope.subjectPlaceholder = string;
    });

    $scope.storage = $localStorage;
    $scope.$on('$ionicView.beforeEnter', function() {
        GetContactsService.load();
    });
})

.controller('FaqsCtrl', function($scope, GetFaqsService, $localStorage, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.Faqs.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });
    $scope.storage = $localStorage;
    $scope.$on('$ionicView.beforeEnter', function() {
        GetFaqsService.load();
    });
})

.controller('NewsCtrl', function($scope, GetNewsService, $localStorage, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.News.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });
    $scope.storage = $localStorage;
    $scope.$on('$ionicView.beforeEnter', function() {
        GetNewsService.load();
    });
})

.controller('OngoingRentalsCtrl', function($ionicHistory, $scope, $localStorage, $localStorage, ServerConnection, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.OngoingRentals.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });

    $scope.doRefresh = function() {
        $scope.load();
        $scope.$broadcast('scroll.refreshComplete');
    };

    $scope.$storage = $localStorage;

    $scope.load = function() {
        ServerConnection.GetCustomerRentalsServiceOngoing();
    }

    $scope.$on('$ionicView.beforeEnter', function() {
        $scope.load();
    });
})

.controller('timelineCtrl', function($scope, $timeout, $ionicScrollDelegate, $ionicLoading, $rootScope, $state, FrontendService, $localStorage, $filter, Error, AppConfig, AppConfig, $translate, ServerConnection, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.timeline.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });

    $scope.$storage = $localStorage;
    $scope.timeline = [];
    $scope.days = {};
    $scope.currencySymbol = AppConfig.currency.symbol;
    $scope.currencyPlacement = AppConfig.currency.placement;
    $scope.today = new Date().setHours(0, 0, 0, 0);
    $scope.todayMidnight = new Date().setHours(23, 59, 59, 99);
    $scope.yesterday = new Date(new Date().setDate(new Date().getDate() - 1)).setHours(0, 0, 0, 0);
    $scope.yesterdayMidnight = new Date(new Date().setDate(new Date().getDate() - 1)).setHours(23, 59, 59, 99);
    $scope.loaded = false;
    $scope.lastBalance = false;

    $scope.loadPath = function(TKRental) {
        $scope.$storage.GetMapDataEx.routes = false;
        $ionicLoading.show();
        FrontendService.get("get-ebike-locations", {
            type: "TKRental",
            StartTime: TKRental.StartTime,
            BikeIdentifier: TKRental.BikeIdentifier,
            EndTime: TKRental.EndTime,
            customerId: $scope.$storage.TKCustomer.CustomerID
        }, function(data) {
            $ionicLoading.hide();
            $scope.$storage.GetMapDataEx.routes = data.bikes;
            $state.go('menu.GetMapDataEx');
        });
    }

    $scope.loadMoreData = function() {
        $scope.RentalsPageNumber++;
        $scope.loadRentals();
    }

    $scope.init = function() {
        $scope.RentalsPageNumber = 1;
        $scope.AccountActivitiesPageNumber = 1;
        $scope.days = {};
    }

    $scope.matchBalance2Rental = function(TKRental) {
        if ($scope.$storage.TKAccountActivities === false) return;
        var balance = false;
        if (angular.isUndefined(TKRental.Balance)) {
            var obj = $filter("filter")($scope.$storage.TKAccountActivities.Activities, {
                RecordTime: TKRental.EndTime.split(".")[0]
            }, true);
            if (obj.length == 1) {
                balance = parseFloat(obj[0].Balance);
            } else {
                var obj = $filter("filter")($scope.$storage.TKAccountActivities.Activities, {
                    RecordTime: TKRental.EndTime.split(".")[0]
                }, function(a, b) {
                    a = new Date(a);
                    check = new Date(a.getTime() - 60000);
                    b = new Date(b);
                    if (check < b) {
                        return true;
                    }
                });
                balance = 0;
                if (obj.length > 0) {
                    balance = parseFloat(obj[0].Balance);
                } else {}
            }
            return balance;
        } else {
            return TKRental.Balance;
        }
    }

    $scope.loadActivities = function(callback) {
        callback = callback || false;
        if (!angular.isUndefined($scope.$storage.TKAccountActivities.PageTotal) && $scope.$storage.TKAccountActivities.PageTotal <= $scope.AccountActivitiesPageNumber) {
            return;
        }
        ServerConnection.GetCustomerAccountActivitiesServiceLoad(function() {
            angular.forEach($scope.$storage.TKAccountActivities.Activities, function(data) {
                if (!angular.isUndefined(data.added)) {
                    data.added = false;
                }
                if (data.Amount == 0) return;
                if (data.Amount >= 0) {
                    data.icon = "fa fa-arrow-up balanced";
                } else {
                    data.icon = "fa fa-arrow-down assertive";
                }
                data.type = "TKAccountActivity";

                data.header = "pages.timeline.TKAccountActivities.header";
                data.RecordTime = data.RecordTime.split(".")[0];
                data.Timestamp = data.RecordTime;
                data.content = '<account-activity></account-activity>';

                if (data.ActivityTypeExternalID != "EXT_WS_CREDIT_CARD" && data.added == false) {
                    data.added = true;
                    $scope.addItem(data);
                }
            });

            if (callback !== false) {
                callback();
            }
            $ionicScrollDelegate.resize();
            $scope.loaded = true;
        }, $scope.AccountActivitiesPageNumber);
    }

    $scope.loadRentals = function(callback) {
        callback = callback || false;
        ServerConnection.GetCustomerRentalsServiceClosed(function() {
            if (callback !== false) {
                callback();
            }

            angular.forEach($scope.$storage.GetCustomerRentals.closed.Rentals, function(data) {
                data.Balance = $scope.matchBalance2Rental(data);

                if (data.Balance == 0) {
                    if ($scope.lastBalance > 0) {
                        data.Balance = $scope.lastBalance;
                    }
                } else {
                    $scope.lastBalance = data.Balance;
                }

                data.header = "pages.GetCustomerRentals.TKRental.header";
                data.type = "TKRental";
                data.Timestamp = data.EndTime;
                if (data.StartLocation === null) data.StartLocation = "??";
                if (data.EndLocation === null) data.EndLocation = "??";
                EndTime = new Date(data.EndTime).getTime() / 1000;
                StartTime = new Date(data.StartTime).getTime() / 1000;
                data.duration = new Date(1970, 0, 1).setSeconds(parseInt(EndTime - StartTime))
                data.content = '<rental-activity></rental-activity>';

                $scope.addItem(data);
            });

            $scope.AccountActivitiesPageNumber++;
            $scope.loadActivities();
            $scope.AccountActivitiesPageNumber++;
            $scope.loadActivities();

            $ionicScrollDelegate.resize();
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }, $scope.RentalsPageNumber);
    }

    $scope.doRefresh = function() {
        $scope.init();
        $scope.loadActivities(function() {
            $scope.loadRentals();
        });
        $scope.$broadcast('scroll.refreshComplete');
    };

    $scope.moreDataCanBeLoaded = function() {
        if ($scope.RentalsPageNumber < $scope.$storage.GetCustomerRentals.closed.PageTotal) {
            return true;
        } else {
            return false;
        }
    }

    $scope.addItem = function(data) {
        data.day = new Date(data.Timestamp).setHours(0, 0, 0, 0);
        if (!$scope.days.hasOwnProperty(data.day)) {
            $scope.days[data.day] = {
                items: [],
                Timestamp: data.day,
                TimestampFull: data.Timestamp
            };
        }
        $scope.days[data.day].items.push(data);
    }

    $scope.init();
    $scope.loadActivities(function() {
        $scope.loadRentals();
    });
    $scope.AccountActivitiesPageNumber++;
    $scope.loadActivities();
})

.controller('GetMapDataExCtrl', function(BatteryIcon, Timer, $ionicPopup, FrontendService, $timeout, $filter, GetLocation, $ionicLoading, Setting, GetMapDataExService, $ionicSideMenuDelegate, $ionicPlatform, $ionicScrollDelegate, $scope, $window, $filter, $http, ServerConnection, $localStorage, $ionicModal, $rootScope, $state, $ionicPlatform, Toast, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.GetMapDataEx.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });

    $scope.BatteryIcon = BatteryIcon;

    $scope.routes = [];
    $scope.routesMarkers = [];

    $scope.$storage = $localStorage;

    $scope.Bookmark = {
        "legend": true
    };

    if (AppConfig.BackendSettings.RENTAL_ALLOW_EXTERNAL_RETURN_ANYWHERE == 1) {
        $scope.Bookmark.rentals = false;
    }

    $scope.showMapTool = false;
    $scope.mapDiv = document.getElementById("map-GetMapDataEx");

    $scope.stationData = false;
    $scope.LocationID = false;

    $scope.modal = false;
    $scope.position = false;

    $scope.markers = [];
    $scope.markersFree = [];

    $scope.showStationInfo = true;

    $scope.iconSize = {
        width: 36,
        height: 45
    };

    $scope.ebikeTrace = [];

    $scope.dronViewActivated = false;

    $rootScope.$on('PositionChanged', function(event, args) {
        $scope.updateDronView();
    });

    $scope.updateDronView = function() {
        if ($scope.dronViewActivated) {
            var position = $rootScope.UserLocation;
            var pars = {
                'target': position.latLng,
                'tilt': 60,
                'duration': 500
            };

            navigator.geolocation.getCurrentPosition(function(data) {
                if (data.coords.heading && !isNaN(data.coords.heading)) {
                    position.coords.heading = data.coords.heading;
                }
                if (position.coords.heading && !isNaN(position.coords.heading) && position.coords.heading > 0) {
                    pars.bearing = position.coords.heading;
                }
                $rootScope.map.setCenter(position.latLng);

                $rootScope.map.getCameraPosition(function(camera) {
                    pars.zoom = camera.zoom;
                    $rootScope.map.animateCamera(pars);
                });
            });
        }
    }

    $scope.ReturnBikeFree = function(rental) {
        rental.loading = true;
        GetLocation.locate(function(position) {
            ServerConnection.RentReturnBikeExternalReturn({
                locationId: '',
                rentalId: rental.RentalID,
                spikeId: '',
                latitude: position.latLng.lat,
                longitude: position.latLng.lng,
                confirmationCode: ''
            }, function(data) {
                $translate('pages.GetMapDataEx.RentReturn.ReturnedBike').then(function(string) {
                    Toast.show(string);
                });
                rental.loading = false;
                $rootScope.map.refreshLayout();
                ServerConnection.GetCustomerRentalsServiceOngoing(function() {});
            });
        });
    }

    $scope.preventClose = function($event) {
        $event.stopPropagation();
    }

    $scope.openMapTool = function(type, $event) {
        $event.stopPropagation();
        angular.forEach($scope.Bookmark, function(el, key) {
            $scope.Bookmark[key] = false;
        });
        $scope.Bookmark[type] = true;

        $scope.showMapTool = true;
        $rootScope.map.setClickable(false);
    }

    $scope.$on('menuOpen', function(event, args) {
        $scope.deactivateMapTool();
        $timeout(function() {
            if ($ionicSideMenuDelegate.getOpenRatio() == true) {
                $rootScope.map.setClickable(false);
            }
        }, 600);
        $rootScope.map.setClickable(false);
        $rootScope.map.refreshLayout();
    });

    $scope.deactivateMapTool = function() {
        angular.forEach($scope.Bookmark, function(el, key) {
            $scope.Bookmark[key] = false;
        });

        if ($scope.showMapTool == true) {
            var state = !$ionicSideMenuDelegate.getOpenRatio();
            $scope.showMapTool = false;
            $timeout(function() {
                $rootScope.map.setClickable(state);
                $rootScope.map.refreshLayout();
            }, 100);

            $timeout(function() {
                $rootScope.map.setClickable(state);
                $rootScope.map.refreshLayout();
            }, 350);

            $timeout(function() {
                $rootScope.map.setClickable(state);
                $rootScope.map.refreshLayout();
            }, 550);
        }
    }

    /**
     * Otevřít detail stanice, pokud existuje nějaký takový požadavek v rootScope.GetMapDataEx
     */
    $scope.ActivateStationDetail = function() {
        if ($rootScope.GetMapDataEx.LocationID !== false) {
            $scope.openStationDialog($rootScope.GetMapDataEx.LocationID);
            $rootScope.GetMapDataEx.LocationID = false;
        };

        if ($rootScope.GetMapDataEx.ReturnBikeExternal !== false) {
            $rootScope.GetMapDataEx.ReturnBikeExternal = false;
            var el = $scope.mapData.Locations[0];
            if (el.distance < AppConfig.BackendSettings.RENTAL_EXTERNAL_MAX_LOCATION_DISTANCE) {
                $scope.openStationDialog(el.LocationID);
            }
        }
    }

    $scope.clearMapRoutes = function() {
        $scope.$storage.GetMapDataEx.routes = false;
        angular.forEach($scope.routes, function(el) {
            el.remove();
        });
        angular.forEach($scope.routesMarkers, function(el) {
            el.remove();
        });
    }

    $scope.placeRoutes = function(center) {
        center = center || false;
        var colors = [];
        colors.push("#78e5fb");
        colors.push("#88ff7c");
        colors.push("#a91b71");

        var ii = 0;
        for (var i in $scope.$storage.GetMapDataEx.routes) {
            var data = $scope.$storage.GetMapDataEx.routes[i];

            var path = [];
            var distance = 0;
            var prev = false;

            angular.forEach(data, function(el, key) {
                if (prev !== false) {
                    distance += getDistanceFromLatLonInKm(prev.Latitude, prev.Longitude, el.Latitude, el.Longitude);
                }
                path.push(new plugin.google.maps.LatLng(el.Latitude, el.Longitude));
                prev = el;
            });

            distance = Math.round(distance * 1000);

            $rootScope.map.addMarker({
                position: path[0],
                icon: 'green',
                zIndex: 10
            }, function(marker) {
                $scope.routesMarkers.push(marker);
            });

            $rootScope.map.addMarker({
                position: path[(path.length - 1)],
                icon: 'red',
                zIndex: 10
            }, function(marker) {
                $scope.routesMarkers.push(marker);
            });

            $rootScope.map.addPolyline({
                    points: path,
                    'color': colors[(ii % colors.length)],
                    'width': 3,
                    'geodesic': true
                },
                function(route) {
                    $scope.routes.push(route);
                    if (ii == 1 && center === true) {
                        $timeout(function() {
                            if (path.length > 0) {
                                $rootScope.map.setCenter(path[Math.round(path.length / 2)]);
                                $rootScope.map.setZoom(14);
                                $rootScope.map.setCenter(path[Math.round(path.length / 2)]);
                            }
                        }, 250);
                    }

                    route.on(plugin.google.maps.event.OVERLAY_CLICK, function() {
                        $translate(['pages.GetMapDataEx.routes.distance', 'pages.GetMapDataEx.routes.remove']).then(function(string) {
                            $rootScope.map.setClickable(false);
                            var confirmRemove = $ionicPopup.confirm({
                                title: string['pages.GetMapDataEx.routes.distance'] + ': ' + $filter('number')(distance) + " m",
                                template: string['pages.GetMapDataEx.routes.remove']
                            });

                            confirmRemove.then(function(res) {
                                $rootScope.map.setClickable(true);
                                if (res) {
                                    $rootScope.ebikeTraceShow = false;
                                    $scope.clearMapRoutes();
                                }
                            });
                        });
                    });
                });

            ii++;
        }
        $scope.$storage.GetMapDataEx.routes = false;
    }

    $scope.dronView = function(close) {
        close = close || false;
        if ($scope.dronViewActivated === true || close) {
            $scope.dronViewActivated = false;
            $rootScope.map.getCameraPosition(function(camera) {
                $rootScope.map.animateCamera({
                    target: camera.target,
                    zoom: camera.zoom,
                    heading: false,
                    tilt: 0,
                    duration: 300
                });
            });
        } else {
            $scope.dronViewActivated = true;
            $scope.updateDronView();
        }
    }

    $scope.loadRealTimeTraceData = function() {
        var FirstStartTime = false;
        var StartTime = false;

        angular.forEach($scope.ebikeTrace, function(el) {
            if (!FirstStartTime || new Date(el.StartTime) < FirstStartTime) StartTime = el.StartTime;
        });

        FrontendService.get("get-ebike-locations", {
            type: "TKRental",
            StartTime: StartTime,
            customerId: $scope.$storage.TKCustomer.CustomerID
        }, function(data) {
            $scope.$storage.GetMapDataEx.routes = data.bikes;

            $ionicLoading.hide();
            $scope.clearMapRoutes();
            $scope.placeRoutes();
        });
    }

    $scope.realTimeTrace = function() {
        $scope.clearMapRoutes();

        if ($rootScope.ebikeTraceShow === true) {
            Timer.remove("realTimeTrace");
            return;
        }

        $rootScope.ebikeTraceShow = true;
        $ionicLoading.show();

        $scope.loadRealTimeTraceData();
    }

    $scope.$on('$ionicView.afterEnter', function() {
        if ($rootScope.map !== false) {
            $scope.updateMap($scope.ActivateStationDetail);
            if ($scope.$storage.GetMapDataEx.routes) {
                $scope.placeRoutes(true);
            }
        } else {
            $timeout(function() {
                $ionicPlatform.ready(function() {
                    $scope.initMap();
                    if ($scope.$storage.GetMapDataEx.routes) {
                        $scope.placeRoutes(true);
                    }
                });
            }, 100);
        }
    });

    $scope.initMap = function() {
        $ionicPlatform.ready(function() {
            var pars = {
                'backgroundColor': 'white',
                'mapType': plugin.google.maps.MapTypeId.ROADMAP,
                'controls': {
                    'compass': true,
                    'myLocationButton': true,
                    'zoom': true
                },
                'gestures': {
                    'scroll': true,
                    'tilt': false,
                    'rotate': false,
                    'zoom': true
                }
            };

            $rootScope.map = plugin.google.maps.Map.getMap($scope.mapDiv, pars);

            $rootScope.map.setClickable(true);
            // $rootScope.map.setDebuggable(true);
            $rootScope.map.on(plugin.google.maps.event.MAP_READY, function() {
                $rootScope.map.setMyLocationEnabled(true);
                $rootScope.map.on(plugin.google.maps.event.MY_LOCATION_BUTTON_CLICK, function() {
                    $scope.dronView(true);
                });
                $rootScope.map.getMyLocation(function(position) {
                    $scope.position = position.latLng;
                    if (!$scope.$storage.GetMapDataEx.routes) {
                        if (!position) {
                            $rootScope.map.setCenter($localStorage.GetMapDataEx.stations);
                            $rootScope.map.setZoom(14);
                        } else {
                            $rootScope.map.setCenter(position.latLng);
                            $rootScope.map.setZoom(16);
                            $rootScope.map.setCenter(position.latLng);
                        }
                    }
                });

                if ($scope.$storage.anonymous) {
                    $scope.icons = "bicycle";
                    GetMapDataExService.get(function() {
                        $scope.mapData = $localStorage.GetMapDataEx.mapData;
                        $scope.assembleMap();
                    });
                } else {
                    ServerConnection.GetCustomerRentalsServiceOngoing(function() {
                        if ($scope.$storage.GetCustomerRentals.ongoing.Rentals.length == 0) {
                            $scope.icons = "bicycle";
                        } else {
                            $scope.icons = "lock";
                        }

                        GetMapDataExService.get(function() {
                            $scope.mapData = $localStorage.GetMapDataEx.mapData;
                            $scope.assembleMap();
                        });
                    });
                }

                Timer.add("GetMapDataExServiceGet", false, function($scope) {
                    GetMapDataExService.get(function() {
                        $scope.updateMap();
                    });
                }, 60000, $scope);
            });
        });
    }

    $scope.setIcons = function(type) {
        if ($scope.icons != type) {
            $scope.icons = type;
        }

        var path = "www/img/icons/";

        var icons = false;
        angular.forEach($scope.markers, function(el) {
            icons = (el.get("icons"));

            if (typeof el !== null) {
                el.setIcon({
                    'url': path + icons[$scope.icons] + ".png",
                    'size': $scope.iconSize
                });
            }
        });
    }

    $scope.updateMap = function(callback) {
        callback = callback || false;
        $scope.mapData = $localStorage.GetMapDataEx.mapData;
        var LocationID = false;

        $scope.AddFreeBikes();

        angular.forEach($scope.markers, function(el) {
            LocationID = el.get("LocationID");
            var obj = $filter("filter")($scope.mapData.Locations, {
                LocationID: LocationID
            }, true);
            icons = $scope.getIcons(obj[0]);
            el.set("icons", icons);
        });
        $scope.setIcons($scope.icons);

        $rootScope.map.refreshLayout();
        if (callback !== false) callback();
    }

    $scope.getIcons = function(obj) {
        var bicycle = "empty";
        var type = "classic";

        if (obj.IsVirtual) {
            type = "virtual"
        }

        if (obj.IsEBikeStation) {
            type = "electro"
        }

        if (obj.Status.totalBikes > 9) {
            bicycle = "9+";
        } else {
            bicycle = obj.Status.totalBikes;
        }

        if (obj.Status.freeLocks > 9) {
            locks = "9+";
        } else {
            locks = obj.Status.freeLocks;
        }

        if (!(parseInt(obj.Status.freeLocks) % 1 === 0)) {
            locks = "unlimited";
        }

        var bike = [type, bicycle, "bike"];
        var lock = [type, locks, "lock"];

        return {
            bicycle: bike.join("-"),
            lock: lock.join("-"),
        };
    }

    $scope.assembleMap = function() {
        if ($scope.position === false) {
            $rootScope.map.setCenter($localStorage.GetMapDataEx.stations);
            $rootScope.map.setZoom(14);
        }

        $scope.AddFreeBikes();
        $scope.AddStations();

        $scope.ActivateStationDetail();
    }

    $scope.AddStations = function() {
        angular.forEach($scope.markers, function(el) {
            el.remove();
        });
        $scope.markers = [];
        $rootScope.map.refreshLayout();

        var id = 0;
        var icons = false;
        angular.forEach($localStorage.GetMapDataEx.mapData.Locations, function(obj, key) {
            id++;
            obj.id = id;
            obj.position = new plugin.google.maps.LatLng(obj.Latitude, obj.Longitude);

            icons = $scope.getIcons(obj);

            $rootScope.map.addMarker({
                id: obj.id,
                icon: {
                    'url': 'www/img/icons/' + icons[$scope.icons] + '.png',
                    'size': $scope.iconSize
                },
                icons: icons,
                AllowExternalReturn: obj.AllowExternalReturn,
                AllowExternalRent: obj.AllowExternalRent,
                IsVirtual: obj.IsVirtual,
                IsElectro: obj.IsEBikeStation,
                ClassicStation: !obj.IsEBikeStation,
                Name: obj.Name,
                info: obj.Status,
                position: obj.position,
                draggable: false,
                LocationID: obj.LocationID,
                map: $rootScope.map,
                shadow: false
            }, function(marker) {
                $scope.markers.push(marker);
                marker.addEventListener(plugin.google.maps.event.MARKER_CLICK, function() {
                    $scope.openStationDialog(obj.LocationID);
                });
            });
        });
    }

    $scope.AddFreeBikes = function() {
        angular.forEach($scope.markersFree, function(el) {
            el.remove();
        });
        $rootScope.map.refreshLayout();
        $scope.markersFree = [];
        angular.forEach($scope.$storage.GetMapDataEx.BikesOutOfLocation, function(obj, key) {
            obj.position = new plugin.google.maps.LatLng(obj.Latitude, obj.Longitude);
            obj.Name = obj.BikeIdentifier + " (" + obj.BikeTypeName + ")";

            var icon = ["cable", "lock"];

            if (obj.IsEBike) {
                icon.push("electro");
            }

            $rootScope.map.addMarker({
                id: 'Free_' + obj.id,
                BikeID: obj.BikeID,
                icon: {
                    'url': 'www/img/icons/' + icon.join("-") + '.png',
                    'size': $scope.iconSize
                },
                IsVirtual: false,
                IsElectro: false,
                ClassicStation: false,
                position: obj.position,
                draggable: false,
                map: $rootScope.map,
                shadow: false
            }, function(freeMarker) {
                $scope.markersFree.push(freeMarker);
                freeMarker.addEventListener(plugin.google.maps.event.MARKER_CLICK, function() {
                    $scope.openFreeBikeDialog(obj.BikeID);
                });
            });
        });
    }

    /**
     * Otevrit dialog free bike
     */
    $scope.openFreeBikeDialog = function(BikeID) {
        $scope.BikeRentedPassword = false;
        $scope.LocationID = false;
        $scope.BikeID = BikeID;
        $scope.$broadcast("ActivateFreeBike");
        $scope.openModal();
    }

    /**
     * Otevrit dialog stanice podle LocationID
     */
    $scope.openStationDialog = function(LocationID) {
        $scope.BikeID = false;
        $scope.LocationID = LocationID;
        $scope.$broadcast("RefreshStationDetail");

        $scope.openModal();
        if (AppConfig.BackendSettings.RENTAL_ALLOW_EXTERNAL_RENTAL == 1 || AppConfig.BackendSettings.RENTAL_ALLOW_EXTERNAL_RETURN == 1) {
            $scope.$broadcast("GetBikesAtLocation");

            if ($scope.$storage.GetCustomerRentals.ongoing.hasOwnProperty("Rentals") && $scope.$storage.GetCustomerRentals.ongoing.Rentals.length == 0) {
                $scope.$storage.temp.RentReturnList = 'rent';
            }
        }
    }

    $ionicModal.fromTemplateUrl('templates/station.html', {
            scope: $scope,
            animation: 'slide-in-up'
        })
        .then(function(modal) {
            $scope.modal = modal;
        });

    $scope.$on('modal.hidden', function() {
        $rootScope.map.setClickable(true);
    });
    $scope.openModal = function() {
        $rootScope.map.setClickable(false);
        $ionicScrollDelegate.scrollTop();
        $scope.modal.show();
    };

    $scope.closeModal = function() {
        $rootScope.map.refreshLayout();
        $rootScope.map.setClickable(true);
        $rootScope.map.setMapToolbarEnabled(false);
        $scope.modal.hide();
    };
})

.controller('GetCustomerCtrl', function($scope, ServerConnection, GetCustomerContractsService, GetCustomer, $localStorage, Error, AppConfig, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.GetCustomer.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });
    $scope.$storage = $localStorage;
    $scope.currencySymbol = AppConfig.currency.symbol;

    $scope.$on('$ionicView.beforeEnter', function() {
        ServerConnection.GetCustomerContractsServiceLoad();

        GetCustomer.get(function(data) {
            $scope.$storage.TKCustomer = data;
        }, function(err) {
            Error.solve(err);
        });
    });
})

.controller('EBikeMotorProfilesCtrl', function($scope, Timer, GetLocation, Speedometer, $rootScope, BatteryIcon, EBikeMotorProfiles, $localStorage, Error, $http, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {

    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.EBikeMotorProfiles.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });

    $scope.speedometerOptions = {
        max: 50,
        markerFont: "italic 1.2em sans-serif",
        markerBaseline: "middle",
        edgeSize: .7,
        endOfNormalDegree: 140,
        endOfWarningDegree: 190,
        edgeOuterColor: "rgb(225, 225, 225)",
        edgeInnerColor: "rgb(120, 120, 120)",
        backgroundColor: 'white',
        markerColor: 'black',
        smallTickColor: 'black',
        largeTickColor: 'black'
    }

    $scope.$storage = $localStorage;
    $scope.BatteryIcon = BatteryIcon;

    $scope.label = "";

    $scope.$on('$ionicView.beforeEnter', function() {
        var labelKey = "general.kmh";
        if ($scope.$storage.distanceUnits == "mi") {
            labelKey = "general.mph";
        }

        $translate(labelKey).then(function(string) {
            $scope.label = string;
        });

        window.plugins.insomnia.keepAwake();

        Timer.add("speedchecker", false, function($scope) {
            GetLocation.locate();
        }, 10000, $scope);
        EBikeMotorProfiles.query(function(data) {
            $scope.$storage.EBikeMotorProfiles = data;
        }, function(err) {
            Error.solve(err);
        });
    });

    $scope.$on('$ionicView.beforeLeave', function() {
        window.plugins.insomnia.allowSleepAgain();
        Timer.remove("speedchecker");
        EBikeMotorProfiles.query(function(data) {
            $scope.$storage.EBikeMotorProfiles = data;
        }, function(err) {
            Error.solve(err);
        });
    });
})

.controller('TKBusinessRuleCtrl', function(AppConfig, $scope, $state, $ionicScrollDelegate, $ionicHistory, Toast, $ionicConfig, $translate, $stateParams, $localStorage, $ionicModal, FrontendService) {
    $scope.$storage = $localStorage;
    $translate("general.back").then(function(string) {
        $ionicConfig.backButton.text(parseHtmlEnteties(string));
    });

    $scope.today = new Date();
    $scope.today.setMilliseconds(0);

    $scope.data = false;
    $scope.ExternalID = $stateParams.ExternalID;
    angular.forEach($localStorage.GetBusinessRules, function(data) {
        if (data.ExternalID == $scope.ExternalID) {
            $scope.data = data;
        }
    });

    // if ($scope.data.DefaultInitialCreditPayment < 1) $scope.data.DefaultInitialCreditPayment = $scope.data.VirtualPrice;
    $scope.data.DefaultInitialCreditPayment = $scope.data.VirtualPrice;
    $scope.data.ListAllowedBikeTypes = [];
    angular.forEach($scope.data.AllowedBikeTypes.TKBikeType, function(val) {
        $scope.data.ListAllowedBikeTypes.push(val.Name);
    });

    $scope.modal = false;
    $scope.sending = false;
    $scope.onlinePayment = false;
    $scope.creditPayment = false;

    $scope.$on('$ionicView.beforeEnter', function() {
        $scope.payment = {};
        if ($scope.$storage.anonymous !== false) {
            string = "pages.GetBusinessRules.anonymous";
        } else {
            string = "pages.GetBusinessRules.logged";
        }
        $translate(string).then(function(string) {
            $scope.payment.Name = parseHtmlEnteties(string);
        });
        $scope.payment.Description = $scope.data.Name;

        $scope.CreateCustomer = {
            ValidFrom: "",
            VoucherCode: "",
            Amount: "",
            Gateway: AppConfig.AddCredit.gateways[0].name,
            Name: "",
            Surname: "",
            PhoneNumber: "",
            EmailAddress: "",
            City: "",
            Street: "",
            PostalCode: ""
        };

        $scope.CreateCustomer.Amount = parseInt($scope.data.DefaultInitialCreditPayment);
        $scope.CreateCustomer.ValidFrom = $scope.today;
    });

    $scope.isBold = function(item) {
        if (item.required) {
            return "tbold";
        }
    }

    $scope.paymentFinished = function(data) {
        data = data || false;
        if (data) {
            console.log(data.message);
            Toast.show(data.message.split("#").join("<br />"), 5000);
        }
        $ionicHistory.nextViewOptions({
            disableBack: true
        });
        $scope.modal.hide();
        if ($scope.payment.Type == "CreateCustomer") {
            if ($scope.payment.hasOwnProperty("login")) {
                $state.go('login', $scope.payment.login);
            } else {
                FrontendService.get('create-customer', {
                    CachedCustomerId: $scope.payment.CachedCustomerId
                }, function(data) {
                    $state.go('login', {
                        card: data.CardNumber,
                        pin: data.Pin
                    });
                })
            }
        }
        if ($scope.payment.Type == "AddContract") {
            $state.go("menu.GetCustomer");
        }
    }

    $ionicModal.fromTemplateUrl('templates/gateway.html', {
            scope: $scope,
            animation: 'slide-in-up'
        })
        .then(function(modal) {
            $scope.modal = modal;

        });

    $scope.openModal = function() {
        $ionicScrollDelegate.scrollTop();
        $scope.modal.show();
    };

    $scope.closeModal = function() {
        $scope.modal.hide();
    };

    $scope.send = function(credit) {
        credit = credit || false;
        $scope.sending = true;
        var params = {};
        var TKContract = {
            ValidFrom: $scope.CreateCustomer.ValidFrom.toISOString(),
            BusinessRuleExtId: $scope.data.ExternalID,
            VoucherCode: $scope.CreateCustomer.VoucherCode
        };

        if ($scope.$storage.anonymous) {
            params.TKContract = TKContract;
            params.Amount = $scope.CreateCustomer.Amount;
            params.Name = $scope.CreateCustomer.Name;
            params.Surname = $scope.CreateCustomer.Surname;
            params.PhoneNumber = $scope.CreateCustomer.PhoneNumber;
            params.EmailAddress = $scope.CreateCustomer.EmailAddress;
            params.City = $scope.CreateCustomer.City;
            params.Street = $scope.CreateCustomer.Street;
            params.PostalCode = $scope.CreateCustomer.PostalCode;
        } else {
            params = TKContract;
        }

        $scope.payment.Amount = $scope.CreateCustomer.Amount;
        $scope.payment.Gateway = $scope.CreateCustomer.Gateway;

        if (TKContract.VoucherCode) {
            $scope.payment.VoucherCode = $scope.CreateCustomer.VoucherCode;
        }

        if ($scope.$storage.anonymous) {
            FrontendService.post('create-customer', params, function(data) {
                $scope.sending = false;

                if (data.CardNumber && data.Pin) {
                    $scope.payment.login = {
                        card: data.CardNumber,
                        pin: data.Pin
                    };
                }
                $scope.payment.CustomerId = data.CustomerId;
                $scope.payment.CachedCustomerId = data.CachedCustomerId;
                $scope.payment.Type = "CreateCustomer";

                $scope.openModal();
            }, function(err) {
                $scope.sending = false;
                console.log(err);

            }, function(err) {
                $scope.sending = false;
                console.log(err);
            });
        } else {
            $scope.payment.Type = "AddContract";
            $scope.payment.CustomerId = $localStorage.TKCustomer.CustomerID;
            FrontendService.post('add-contract', params, function(data) {
                $scope.sending = false;

                Toast.show(data.message);
                if (credit === true) {
                    $ionicHistory.nextViewOptions({
                        disableBack: true
                    });
                    $state.go('menu.GetCustomer');
                } else {
                    $scope.openModal();
                }
            }, function(err) {
                $scope.sending = false;
                console.log(err);
            }, function(err) {
                $scope.sending = false;
                console.log(err);
            });
        }
    }
})

.controller('GetBusinessRulesCtrl', function($rootScope, $ionicScrollDelegate, $ionicModal, $ionicHistory, $translate, $scope, Toast, FrontendService, $state, $localStorage, $cordovaInAppBrowser, Error, ServerConnection, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.GetBusinessRules.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });
    $scope.title = false;
    $scope.$storage = $localStorage;

    $scope.$on('$ionicView.beforeEnter', function() {
        if ($scope.$storage.anonymous !== false) {
            string = "pages.GetBusinessRules.anonymous";
        } else {
            string = "pages.GetBusinessRules.logged";
        }
        $translate(string).then(function(string) {
            $scope.title = parseHtmlEnteties(string);
        });
    });

    $scope.$on('$ionicView.beforeEnter', function() {
        FrontendService.get("get-business-rules", false, function(data) {
            $localStorage.GetBusinessRules = data.TKBusinessRules;
        });
    });
})

.controller('MenuCtrl', function($scope, $ionicSideMenuDelegate, $state, $ionicHistory, $localStorage, $translate, $window, $http, AppConfig, $translate, $rootScope, $ionicPlatform, $translate, $cordovaGoogleAnalytics, Timer) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.Menu.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });

    $scope.go = function(state) {
        $ionicHistory.nextViewOptions({
            disableBack: true
        });

        $state.go(state);
    }

    $scope.$watch(function() {
        return $ionicSideMenuDelegate.getOpenRatio();
    }, function(newValue, oldValue) {
        if (newValue == 0) {
            if ($state.current.name == 'menu.GetMapDataEx') {
                if ($rootScope.map !== false) {
                    $rootScope.map.setClickable(true);
                }
            } else {}
            $scope.hideLeft = true;
        } else {
            if ($state.current.name == 'menu.GetMapDataEx') {
                if ($rootScope.map !== false) {
                    $rootScope.$broadcast('menuOpen');
                    $rootScope.map.setClickable(false);
                }
            }
            $scope.hideLeft = false;
        }
    });

    $scope.$storage = $localStorage;
    $scope.logout = function() {
        $scope.$storage.OAuth = false;
        $scope.$storage.anonymous = false;
        $scope.$storage.Login = {};
        var LastChangelog = $scope.$storage.LastChangelog
        $localStorage.$reset($rootScope.defaultLocalStorage);
        $localStorage.LastChangelog = LastChangelog;
        $rootScope.initAppData();
        Timer.resetAll();
        delete $http.defaults.headers.common['Authorization'];
        $state.go("login");
    }

    $scope.register = function() {
        $ionicHistory.nextViewOptions({
            disableBack: true
        });
        $state.go("menu.GetBusinessRules");
    }
})

.controller('applicationSettingsCtrl', function($scope, $ionicHistory, $state, $translate, $localStorage, $sessionStorage, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.applicationSettings.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });
    $scope.$storage = $localStorage;

    $scope.navigationApps = [];

    $scope.openDashboard = function() {
        $ionicHistory.nextViewOptions({
            disableBack: true
        });
        $state.go('menu.dashboard');
    }

    if (AppConfig.navigation.UrbanCycles) {
        $scope.navigationApps.push({
            code: "UrbanCycles",
            string: 'pages.GetMapDataEx.navigationApps.UrbanCycles'
        });
    }
    $scope.navigationApps.push({
        code: "NativeApp",
        string: 'pages.GetMapDataEx.navigationApps.NativeApp'
    });

    $scope.moveItem = function(item, fromIndex, toIndex) {
        var temp = $scope.$storage.dashboardModules;
        temp.splice(fromIndex, 1);
        temp.splice(toIndex, 0, item);
        angular.forEach(temp, function(el, key) {
            temp[key].priority = key + 1;
        });
        $scope.$storage.dashboardModules = temp;
    };

    $scope.distanceUnits = [{
        code: "km",
        string: "general.km"
    }, {
        code: "mi",
        string: "general.mi"
    }];

    $scope.speedometer = [{
        code: "analog",
        string: "speedometer.analog"
    }, {
        code: "digital",
        string: "speedometer.digital"
    }];


    $scope.homeSettings = [{
        code: "menu.dashboard",
        string: "pages.dashboard.header"
    }, {
        code: "menu.timeline",
        string: "pages.timeline.header"
    }, {
        code: "menu.GetMapDataEx",
        string: "pages.GetMapDataEx.header"
    }];
})

.controller('AdvertCtrl', function($scope, Timer, $state, $localStorage, AppConfig, $ionicLoading, $rootScope, $cordovaInAppBrowser) {

    $scope.path = false;
    $scope.height = false;
    $scope.width = false;
    $scope.countdown = 5;

    $scope.$on('modal.shown', function() {
        if ($localStorage.Advert.hasOwnProperty($scope.$parent.Advert.code)) {
            $scope.countdown = 3;
        }
        $scope.path = $scope.$parent.AdvertImage;
        $scope.height = $scope.$parent.AdvertHeight;
        $scope.width = $scope.$parent.AdvertWidth;

        Timer.add("Advert", false, function($scope) {
            $scope.countdown--;
            if ($scope.countdown == 0) {
                Timer.remove("Advert");
                $scope.closeModal();
            }
        }, 1000, $scope);
    });

    $scope.openAdvert = function() {
        Timer.remove("Advert");
        $localStorage.Advert[$scope.$parent.Advert.code] = true;

        if ($rootScope.platform == 'android') {
            $ionicLoading.show();
            var options = {
                location: 'yes',
                clearcache: 'yes',
                toolbar: 'no'
            };

            var br = $cordovaInAppBrowser.open($scope.$parent.Advert.url, '_system', options).then(function(event) {
                console.log(event);
            }).catch(function(err) {
                console.log(err);
            });

            $rootScope.$on('$cordovaInAppBrowser:loadstop', function(e, event) {
                $scope.closeModal();
                $ionicLoading.hide();
            });

            $rootScope.$on('$cordovaInAppBrowser:loaderror', function(e, event) {
                $scope.closeModal();
                $ionicLoading.hide();
            });

        }

        if ($rootScope.platform == 'ios') {

        }
        window.open($scope.$parent.Advert.url, '_system');
        $scope.closeModal();
        $ionicLoading.hide();
    }

    $scope.closeModal = function() {
        $scope.$parent.loginProcess();
        $scope.AdvertModal.hide();
    };
})

.controller('GatewayCtrl', function($scope, $filter, Timer, $sce, $state, Toast, FrontendService, $timeout, AppConfig, $translate) {

    $scope.setUrl = function() {
        if (!$scope.payment.uniqueId) return;
        if ($scope.payment.hasOwnProperty("gatewayUrl")) {
            return $sce.trustAsResourceUrl($scope.payment.gatewayUrl);
        }
    };

    $scope.activatePending = function() {
        Timer.add("PaymentFinished", false, function($scope) {
            if ($scope.payment && $scope.payment.hasOwnProperty("uniqueId")) {
                FrontendService.get("payment", {
                    uniqueId: $scope.payment.uniqueId
                }, function(data) {
                    if (data.result != "1") {
                        $scope.finished = true;
                        $scope.iframe = false;
                        $scope.browser = false;
                        Timer.remove("PaymentFinished");
                        delete $scope.payment.uniqueId;

                        if (data.result == 3) {
                            $scope.success = true;
                        } else {
                            $scope.success = false;
                        }

                        $timeout(function() {
                            $scope.$parent.paymentFinished(data);
                        }, 3000);
                    }
                });
            }
        }, 5000, $scope);
    }

    $scope.$on('modal.shown', function() {
        $scope.spinner = true;
        $scope.payment = false;
        $scope.loaded = 0;

        $scope.browser = false;
        $scope.iframe = false;
        $scope.finished = false;
        $scope.success = false;

        $scope.payment = $scope.$parent.payment;
        $scope.payment.CleanScreen = true;
        $scope.payment.URL_SCHEME = AppConfig.URL_SCHEME;

        var Gateway = $filter("filter")(AppConfig.AddCredit.gateways, {
            name: $scope.payment.Gateway
        }, true);

        if (Gateway.length > 0) Gateway = Gateway[0];

        if (Gateway.iframe === true) {
            $scope.iframe = true;
        }

        FrontendService.post("payment", $scope.payment, function(data) {
            $scope.payment.uniqueId = data.uniqueId;
            $scope.payment.callbackUrl = data.callbackUrl;
            $scope.payment.gatewayFinishedUrl = data.gatewayFinishedUrl;
            $scope.payment.gatewayUrl = data.gatewayUrl;
            $scope.payment.currency = data.currency;

            $scope.spinner = false;

            if ($scope.iframe === false) {
                $scope.browser = true;
                $scope.activatePending();
                window.open($scope.payment.gatewayUrl, '_system');
            }
        }, function(err) {
            $scope.$parent.modal.hide();
        }, function(err) {
            $scope.$parent.modal.hide();
        });
    });

    $scope.iframeLoaded = function() {
        $scope.loaded++;

        if ($scope.loaded == 2) {
            $scope.spinner = false;
            $scope.activatePending();
        }
    }
})

.controller('AddCreditCtrl', function($ionicModal, Timer, $filter, $stateParams, $scope, $ionicScrollDelegate, FrontendService, Toast, $state, $rootScope, $localStorage, $cordovaInAppBrowser, $translate, $ionicHistory, ServerConnection, Error, AppConfig, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.AddCredit.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });
    $scope.$storage = $localStorage;

    $scope.modal = false;

    $scope.$on('$ionicView.beforeEnter', function() {
        $scope.payment = {};
    });

    $scope.paymentFinished = function(data) {
        data = data || false;
        if (data) {
            Toast.show(data.message, 5000);
        }
        $scope.modal.hide();
        $ionicHistory.nextViewOptions({
            disableBack: true
        });
        $state.go('menu.GetCustomer');
    }

    $scope.currencySymbol = AppConfig.currency.symbol;

    $scope.$on('modal.hidden', function() {
        $scope.resetPayment();
    });

    $scope.openModal = function() {
        $ionicScrollDelegate.scrollTop();
        $scope.modal.show();
    };

    $scope.closeModal = function() {
        $scope.resetPayment();
        $scope.modal.hide();
    };

    $scope.resetPayment = function() {
        Timer.remove("PaymentFinished");
        $scope.payment = {};
        $scope.form = {
            amount: AppConfig.AddCredit.minAmount,
            gateway: AppConfig.AddCredit.gateways[0].name
        };
    }

    $ionicModal.fromTemplateUrl('templates/gateway.html', {
            scope: $scope,
            animation: 'slide-in-up'
        })
        .then(function(modal) {
            $scope.modal = modal;
        });

    $scope.sendPayment = function() {
        $scope.spinner = true;

        $scope.payment.Amount = this.form.amount;
        $scope.payment.Gateway = this.form.gateway;
        $scope.payment.CustomerId = $localStorage.TKCustomer.CustomerID;
        $scope.payment.Type = "AddCredit";

        $translate(['pages.AddCredit.header']).then(function(string) {
            $scope.payment.Name = string['pages.AddCredit.header'];
            $scope.payment.Description = string['pages.AddCredit.header'];
            $scope.openModal();
        });
    }

    $scope.resetPayment();
})

.controller('loginCtrl', function($scope, ChangeLog, $ionicScrollDelegate, $ionicModal, $ionicPlatform, $ionicHistory, $stateParams, $state, ServerLogin, $localStorage, $translate, $translate, $ionicLoading, Toast, $rootScope, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        // if (AppConfig.GoogleAnalytics) {
        // $translate('pages.login.header').then(function(string) {
        //     $cordovaGoogleAnalytics.trackView(string);
        // });
        // }
    });

    $scope.$storage = $localStorage;
    $scope.ChangeLog = false;
    $scope.modal = false;

    $scope.anonymousLogin = function(page) {
        page = page || "menu.GetMapDataEx";
        $translate("pages.login.messages.anonymous").then(function(string) {
            Toast.show(string);
        });
        $scope.$storage.anonymous = true;
        $state.go(page);
        $scope.$storage.OAuth = false;
    }

    $scope.openModal = function() {
        $ionicScrollDelegate.scrollTop();
        $scope.modal.show();
    };

    $scope.closeModal = function() {
        $scope.loginProcess();
        $scope.$storage.LastChangelog = AppConfig.version;
        $scope.modal.hide();
    };

    $scope.loginProcess = function() {

        if ($scope.$storage.Login) {
            if ($scope.$storage.Login.CardNumber) {
                $scope.form.CardNumber = $scope.$storage.Login.CardNumber;
            }

            if ($scope.$storage.Login.pin) {
                $scope.form.pin = $scope.$storage.Login.pin;
            }
        }

        if ($rootScope.preventAutoLogin === true) return false;

        if (typeof $stateParams.card !== false && $stateParams.card > 0) {
            $scope.form.CardNumber = $stateParams.card;
        }
        if (typeof $stateParams.pin !== false && $stateParams.pin > 0) {
            $scope.form.pin = $stateParams.pin;
        }

        if ($scope.form.pin !== '' && $scope.form.CardNumber !== '') {
            $scope.doLogin();
        }
    }

    $scope.showAdvert = function() {
        var paths = {
            "ios": {
                "iphone5": "Default-568h@2x~iphone.jpg",
                "iphone6": "Default-667h.jpg",
                "iphone6+": "Default-736h.jpg",
                "ipadRetina": "Default-Portrait@2x~ipad.jpg",
                "ipad": "Default-Portrait~ipad.jpg",
                "iphone4": "Default@2x~iphone.jpg",
                "iphone3": "Default~iphone.jpg",
            },
            "android": {
                "ldpi": "drawable-port-ldpi-screen.jpg",
                "mdpi": "drawable-port-mdpi-screen.jpg",
                "hdpi": "drawable-port-hdpi-screen.jpg",
                "xhdpi": "drawable-port-xhdpi-screen.jpg",
                "xxhdpi": "drawable-port-xxhdpi-screen.jpg",
                "xxxhdpi": "drawable-port-xxxhdpi-screen.jpg"
            }
        };

        $scope.AdvertImage = paths[$rootScope.platform][$scope.AdvertCode];

        $scope.AdvertImage = ["img/advert", AppConfig.Advert[0].code, $rootScope.platform, $scope.AdvertImage].join("/");

        $ionicModal.fromTemplateUrl('templates/advert.html', {
                scope: $scope,
                animation: 'slide-in-up'
            })
            .then(function(modal) {
                $scope.AdvertModal = modal;
                $scope.AdvertModal.show();
            });
    }

    $scope.$on('$ionicView.beforeEnter', function() {
        $scope.form = {
            CardNumber: '',
            pin: ''
        };

        $ionicPlatform.ready(function() {

            if (ChangeLog.hasOwnProperty(AppConfig.version)) {
                $scope.ChangeLog = false;
                if ($scope.$storage.LastChangelog === false || ($scope.$storage.LastChangelog < AppConfig.version)) {
                    if (ChangeLog[AppConfig.version].hasOwnProperty($scope.$storage.lang)) {
                        $scope.ChangeLog = ChangeLog[AppConfig.version][$scope.$storage.lang];
                    } else {
                        if (ChangeLog[AppConfig.version].hasOwnProperty(AppConfig.lang)) {
                            $scope.ChangeLog = ChangeLog[AppConfig.version][AppConfig.lang];
                        }
                    }
                }

                var empty = true;
                angular.forEach($scope.ChangeLog, function(el) {
                    if (el.length > 0) empty = false;
                });
                if (empty === true) {
                    $scope.ChangeLog = false;
                }
            }

            if ($scope.ChangeLog !== false) {
                $ionicModal.fromTemplateUrl('templates/changelog.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    })
                    .then(function(modal) {
                        $scope.modal = modal;
                        $scope.openModal();
                    });

            } else if (AppConfig.hasOwnProperty("Advert") && AppConfig.Advert.length > 0 && AppConfig.Advert[0].hasOwnProperty("code")) {

                $scope.Advert = AppConfig.Advert[0];

                window.plugins.screensize.get(function(val) {
                    if ($rootScope.platform == "ios") {
                        $scope.AdvertHeight = val.height / val.scale;
                        $scope.AdvertWidth = val.width / val.scale;
                    }
                    if ($rootScope.platform == "android") {
                        $scope.AdvertHeight = val.height / val.densityValue;
                        $scope.AdvertWidth = val.width / val.densityValue;
                    }


                    if ($rootScope.platform == "ios") {
                        var code = "";
                        switch (val.height) {
                            case 1024:
                                if (val.scale == 1) {
                                    code = "ipad";
                                } else {
                                    code = "ipadRetina";
                                }
                                break;
                            case 736:
                                code = "iphone6+";
                                break;
                            case 667:
                                code = "iphone6";
                                break;
                            case 568:
                                code = "iphone5";
                                break;
                            case 480:
                                if (val.scale == 1) {
                                    code = "iphone3";
                                } else {
                                    code = "iphone4";
                                }
                                break;
                            default:
                                code = "iphone6";
                        }
                    }

                    $scope.AdvertCode = code;

                    if ($rootScope.platform == "android") {
                        $scope.AdvertCode = val.densityBucket;
                    }
                    $scope.showAdvert();
                });

            } else {
                $scope.loginProcess();
            }
        });
    });

    $scope.doLogin = function() {
        try {
            ServerLogin.doLogin($scope.form);
        } catch (e) {
            console.log(e);
        }
    }
})

.controller('IntroCtrl', function($scope, $translate, Toast, $state, $ionicHistory, $localStorage, $ionicSlideBoxDelegate, AppConfig, $translate, $ionicPlatform, $translate, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
        if (AppConfig.GoogleAnalytics) {
            // $translate('pages.Intro.header').then(function(string) {
            //     $cordovaGoogleAnalytics.trackView(string);
            // });
        }
    });

    $scope.$storage = $localStorage;
    $scope.lang = AppConfig.lang;
    $scope.slideIndex = false;

    $ionicHistory.nextViewOptions({
        disableBack: true
    });

    $scope.$on('$ionicView.enter', function() {
        $ionicSlideBoxDelegate.slide(0);
        $scope.slideMax = $ionicSlideBoxDelegate.slidesCount();
        $scope.slideMax--;
    });

    $scope.startApp = function() {
        $translate("pages.intro.thanks").then(function(string) {
            Toast.show(string);
        });
        $scope.$storage.intro = AppConfig.version;
        if ($scope.$storage.OAuth !== false || $scope.$storage.anonymous !== false) {
            $state.go('menu.GetMapDataEx');
        } else {
            $state.go('login');
        }
    };
    $scope.next = function() {
        $ionicSlideBoxDelegate.next();
    };
    $scope.previous = function() {
        $ionicSlideBoxDelegate.previous();
    };

    $scope.slideChanged = function(index) {
        $scope.slideIndex = index;
    };
});