angular.module('app.routes', [])

.config(function($stateProvider, $urlRouterProvider, $httpProvider) {
    $stateProvider
        .state('menu.dashboard', {
            url: '/dashboard',
            views: {
                'app': {
                    templateUrl: 'templates/dashboard.html',
                    controller: 'dashboardCtrl'
                }
            }
        })

    .state('menu.timeline', {
        url: '/timeline',
        views: {
            'app': {
                templateUrl: 'templates/timeline.html',
                controller: 'timelineCtrl'
            }
        }
    })

    .state('menu.GetMapDataEx', {
        url: '/GetMapDataEx',
        id: 'GetMapDataEx',
        views: {
            'app': {
                templateUrl: 'templates/GetMapDataEx.html',
                controller: 'GetMapDataExCtrl'
            }
        }
    })

    .state('menu', {
        url: '/app',
        templateUrl: 'templates/menu.html',
        abstract: true,
        controller: 'MenuCtrl'
    })

    .state('menu.GetCustomer', {
        url: '/GetCustomer',
        views: {
            'app': {
                templateUrl: 'templates/GetCustomer.html',
                controller: 'GetCustomerCtrl'
            }
        }
    })

    .state('menu.EBikeMotorProfiles', {
        url: '/EBikeMotorProfiles',
        views: {
            'app': {
                templateUrl: 'templates/EBikeMotorProfiles.html',
                controller: 'EBikeMotorProfilesCtrl'
            }
        }
    })

    .state('menu.OngoingRentals', {
        url: '/OngoingRentals',
        views: {
            'app': {
                templateUrl: 'templates/OngoingRentals.html',
                controller: 'OngoingRentalsCtrl'
            }
        }
    })

    .state('menu.applicationSettings', {
        url: '/settings',
        views: {
            'app': {
                templateUrl: 'templates/applicationSettings.html',
                controller: 'applicationSettingsCtrl'
            }
        }
    })

    .state('menu.bugReport', {
        url: '/bugReport',
        views: {
            'app': {
                templateUrl: 'templates/bugReport.html',
                controller: 'bugReportCtrl'
            }
        }
    })

    .state('menu.AddCredit', {
        url: '/AddCredit',
        views: {
            'app': {
                templateUrl: 'templates/AddCredit.html',
                controller: 'AddCreditCtrl'
            }
        }
    })

    .state('menu.GetBusinessRules', {
        url: '/GetBusinessRules',
        views: {
            'app': {
                templateUrl: 'templates/GetBusinessRules.html',
                controller: 'GetBusinessRulesCtrl'
            }
        }
    })

    .state('menu.TKBusinessRule', {
        url: '/GetBusinessRules/:ExternalID',
        views: {
            'app': {
                templateUrl: 'templates/TKBusinessRule.html',
                controller: 'TKBusinessRuleCtrl'
            }
        }
    })

    .state('menu.News', {
        url: '/News',
        views: {
            'app': {
                templateUrl: 'templates/News.html',
                controller: 'NewsCtrl'
            }
        }
    })

    .state('menu.Faqs', {
        url: '/Faqs',
        views: {
            'app': {
                templateUrl: 'templates/Faqs.html',
                controller: 'FaqsCtrl'
            }
        }
    })

    .state('menu.Infos', {
        url: '/Infos',
        views: {
            'app': {
                templateUrl: 'templates/Infos.html',
                controller: 'InfosCtrl'
            }
        }
    })

    .state('menu.Contacts', {
        url: '/Contacts',
        views: {
            'app': {
                templateUrl: 'templates/Contacts.html',
                controller: 'ContactsCtrl'
            }
        }
    })

    .state('intro', {
        url: '/intro',
        templateUrl: 'templates/intro.html',
        controller: 'IntroCtrl'
    })

    .state('login', {
        url: '/login',
        templateUrl: 'templates/login.html',
        controller: 'loginCtrl',
        params: {
            card: false,
            pin: false
        }
    })

    $urlRouterProvider.otherwise('/login')
});
